function onHelp()
{
  window.open('isolineFilterHelp.html','isolineThresholdFilterHelp','menubar=no,width=800,resizable=yes,toolbar=no,location=no,directories=no,status=no');
}

// set up the various xul elements to display according to the state of the isoline filter
function onLoad()
{

  // fetch isolineFilter ojbect
  window.isolineFilter = window.arguments[0].isolineFilter;

  // extract threshold filter options into variables
  var isovalue = window.isolineFilter.isovalue;
  var density = window.isolineFilter.density;
  
  // create objects to reference the sliders 
  var isovalueSlider = document.getElementById("isovalue-slider");
  var densitySlider = document.getElementById("density-slider");
  
  // add listeners to the sliders
  isovalueSlider.addEventListener("DOMAttrModified", isovalue_slider, false);
  densitySlider.addEventListener("DOMAttrModified", density_slider, false);

  // set inital position of sliders
  var maxpos = isovalueSlider.getAttribute("maxpos");
  isovalueSlider.setAttribute("curpos",isovalue * maxpos);
  maxpos = densitySlider.getAttribute("maxpos");
  densitySlider.setAttribute("curpos",density * maxpos);

  // set initial values of textboxes
  document.getElementById("isovalue-textbox").setAttribute("value",isovalue);
  document.getElementById("density-textbox").setAttribute("value",density);

 	// refocus window so that fragmented image updates
	// note we have to delay as the window is not actually drawn until AFTER the onload
	// function is executed
	setTimeout('self.focus()',20);

}


function onClose() {
}

function onCancel() {
}

// Called if the user clicks OK
function onOK() {

	// apply the filter
	window.isolineFilter.apply_filter();

	// return false so that the window does not close
  return false;
}


// red, green and blue slider code is very similar, see if it can be moved into one function.

// update window.isolineFilter.redWeight and the red weight text box when slider is moved

// update window.isolineFilter.blueWeight and the blue weight text box when slider is moved
function density_slider()
{
	update_slider("density");
}

function isovalue_slider()
{
	update_slider("isovalue");
}

function update_slider(variableName)
{

		var weightVariable = "window.isolineFilter." + variableName;		
		var weightSliderElementId = variableName + "-slider";
		var weightTextboxId = variableName + "-textbox";

		
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		
		// fetch the weight slider that matches up to the slider element id
		var weightSlider = document.getElementById(weightSliderElementId);
		
		// These attributes must be specified in the xul so that they are fetchable
		weightSlider.maxValue = weightSlider.getAttribute("maxpos");
		weightSlider.value = weightSlider.getAttribute("curpos");
		
		// Unfortunately we are grabbing mouse move events and we have to check if 
		// the value has actually changed.
		if (weightSlider.previousValue != weightSlider.value) {
			
			weightSlider.previousValue = weightSlider.value;
			
			// generate value between 0 and 1
			var weight = 1.0 * weightSlider.value / weightSlider.maxValue;
			
			// assign weightVariable to have generated weight
			// there are only 3 possible values for weightVariable
			// as we check the colour it should be impossible to generate an incorrect or malicious value
			eval(weightVariable + " = weight");
			
			// update text box
			document.getElementById(weightTextboxId).setAttribute("value",weight);
			
		}
}









